// След половин час интензивен разговор с chatGPT, успях да изкарам решение от него за 60 точки :)
// Не препоръчвам преглеждането на това решение. 

#include <iostream>
#include <vector>

using namespace std;

int n;
int a[25], b[25];
int min_flips = 1e9;
vector<int> flip_list;

void find_min_flips(int mask) {
    int curr_flips = 0;
    vector<pair<int, int>> rectangles;
    for (int i = 0; i < n; i++) {
        if (mask & (1 << i)) {
            curr_flips++;
            rectangles.push_back({b[i], a[i]});
        } else {
            rectangles.push_back({a[i], b[i]});
        }
    }

    bool valid = true;
    for (int i = 1; i < n; i++) {
        if (rectangles[i].first > rectangles[i-1].first || rectangles[i].second > rectangles[i-1].second) {
            valid = false;
            break;
        }
    }

    if (valid && curr_flips < min_flips) {
        min_flips = curr_flips;
        flip_list.clear();
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                flip_list.push_back(i + 1);
            }
        }
    }
}

int main() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
    }

    for (int mask = 0; mask < (1 << n); mask++) {
        find_min_flips(mask);
    }

    if (min_flips == 1e9) {
        cout << "Impossible!" << endl;
    } else {
        cout << min_flips << endl;
        for (int i = 0; i < flip_list.size(); i++) {
            cout << flip_list[i] << " ";
        }
        cout << endl;
    }

    return 0;
}