#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>

const int MAXN = 100000 + 10;
const int INF  = 1e9;

int n;
int a[MAXN];
int b[MAXN];
int main()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i] >> b[i];
    }

    int ans = 0;
    int cnt[2] = {1, 0}, curr = 0;
    for (int i = 2 ; i <= n ; ++i)
    {
        if (std::max(a[i-1], b[i-1]) < std::max(a[i], b[i]) || std::min(a[i-1], b[i-1]) < std::min(a[i], b[i]))
        {
            // First case
            std::cout << "Impossible!\n";
            return 0;
        }

        if (std::min(a[i-1], b[i-1]) >= std::max(a[i], b[i]))
        {
            // Second case
            ans += std::min(cnt[0], cnt[1]);
            cnt[0] = 1;
            cnt[1] = 0;
            curr = 0;
            continue;
        }

        if (a[i-1] >= a[i] && b[i-1] >= b[i])
        {
            // Third case
            cnt[curr]++;
            continue;
        }

        // Forth case
        curr = 1 - curr;
        cnt[curr]++;
    }

    // Ending talks
    ans += std::min(cnt[0], cnt[1]);
    std::cout << ans << '\n';
    return 0;
}