#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>

const int MAXN = 100000 + 10;
const int INF  = 1e9;

int n;
int a[MAXN];
int b[MAXN];
int chosen[2];
int rotated[2];
int main()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i] >> b[i];
    }

    int ans = n;
    int curr = 0;
    for (int i = 0 ; i <= n ; ++i)
    {
        if (i != 0) 
        {
            std::swap(a[i], b[i]);
            chosen[curr] = i;
            curr++;
        }

        for (int j = i + 1 ; j <= n + 1 ; ++j)
        {
            if (j != n + 1) 
            {
                std::swap(a[j], b[j]);
                chosen[curr] = j;
                curr++;
            }

            bool canBuild = true;
            for (int k = 1 ; k < n && canBuild ; ++k)
            {
                if (a[k] < a[k + 1] || b[k] < b[k + 1])
                {
                    canBuild = false;
                }
            }

            if (canBuild && curr < ans)
            {
                ans = curr;
                rotated[0] = chosen[0];
                rotated[1] = chosen[1];
            }

            if (j != n + 1) 
            {
                std::swap(a[j], b[j]);
                curr--;
            }
        }

        if (i != 0)
        {
            std::swap(a[i], b[i]);
            curr--;
        }
    }

    if (ans == n)
    {
        std::cout << "Impossible!\n";
    } else
    {
        std::cout << ans << '\n';
        for (int i = 0 ; i < ans ; ++i)
        {
            std::cout << rotated[i] << ' ';
        }

        std::cout << '\n';
    }

    return 0;
}