#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>

const int MAXN = 100000 + 10;
const int INF  = 1e9;

int n;
int a[MAXN];
int b[MAXN];
int aCopy[MAXN];
int bCopy[MAXN];
int first[MAXN];
int second[MAXN];

int main()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i] >> b[i];
        aCopy[i] = a[i];
        bCopy[i] = b[i];
    }

    int ans = INF, curr = 0;
    for (int i = 2 ; i <= n ; ++i)
    {
        if (a[i] > a[i-1] || b[i] > b[i-1])
        {
            curr++;
            first[curr] = i;
            std::swap(a[i], b[i]);
        }

        if (a[i] > a[i-1] || b[i] > b[i-1])
        {
            curr = INF;
            break;
        }
    }

    ans = std::min(ans, curr);
    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] = aCopy[i];
        b[i] = bCopy[i];
    }
 
    curr = 1;
    second[1] = 1;
    std::swap(a[1], b[1]);
    for (int i = 2 ; i <= n ; ++i)
    {
        if (a[i] > a[i-1] || b[i] > b[i-1])
        {
            curr++;
            second[curr] = i;
            std::swap(a[i], b[i]);
        }

        if (a[i] > a[i-1] || b[i] > b[i-1])
        {
            curr = INF;
            break;
        }
    }

    bool isFirst = true;
    if (curr < ans)
    {
        isFirst = false;
        ans = curr;
    }

    if (ans == INF) std::cout << "Impossible!\n";
    else
    {
        std::cout << ans << '\n';
        if (isFirst)
        {
            for (int i = 1 ; i <= ans ; ++i)
            {
                std::cout << first[i] << ' ';
            }

            std::cout << '\n';
        } else
        {
            for (int i = 1 ; i <= ans ; ++i)
            {
                std::cout << second[i] << ' ';
            }

            std::cout << '\n';
        }
    }
    
    return 0;
}